#include "mpi.h"
int main (int argc,char *argv[])
{
  int        nb_processus, rang, num_proc_precedent, num_proc_suivant ;
  int        i ;
  const int  etiquette=300 ;
  MPI_Status statut ;
  float      T[2], V[2];
  MPI_Init (&argc, &argv) ;
  MPI_Comm_rank (MPI_COMM_WORLD, &rang) ;
  MPI_Comm_size (MPI_COMM_WORLD, &nb_processus) ;
  num_proc_precedent = (nb_processus+rang-1) % nb_processus ;
  num_proc_suivant = (rang+1) % nb_processus ;
  for (i = 0; i <= 1; i++)
   T[i]=0.1*rang*(i+1) ;
  if (rang == 0)
     {
     MPI_Send (T, 2, MPI_FLOAT, num_proc_suivant, etiquette, MPI_COMM_WORLD) ;
     MPI_Recv (V, 2, MPI_FLOAT, num_proc_precedent, etiquette, MPI_COMM_WORLD, &statut) ;
     }
  else
     {
     MPI_Recv (V, 2, MPI_FLOAT, num_proc_precedent, etiquette, MPI_COMM_WORLD, &statut) ;
     MPI_Send (T, 2, MPI_FLOAT, num_proc_suivant, etiquette, MPI_COMM_WORLD) ;
     }
     printf ("Moi=%d, j'ai recu le tableau de valeurs %f %f du coeur=%d\n",
             rang, V[0], V[1], num_proc_precedent) ;
  MPI_Finalize() ;
}
