clear all;
fprintf('Methode iterative du gradient conjugue');
n=32;
h=1/n;
n=n-1;
pi=acos(-1);
pi2 = 1./(pi*pi);
a=zeros(n,3);
b=zeros(1,n);
x=zeros(1,n);
xe=zeros(1,n);
r=zeros(1,n);
p=zeros(1,n);
q=zeros(1,n);
Kmax= 1000000;
epsilon=1e-12;
a(1,2)=+1;
a(1,3)=-0.5;
for i=2:n-1
  a(i,1)=-0.5;
  a(i,2)=+1;
  a(i,3)=-0.5;
end
a(n,1)=-0.5;
a(n,2)=+1;
for i=1:n
  z=i*h;
  b(i)= h*h*12.*0.5;
  xe(i) = 6*z*(1-z);
% b(i) = h*h*sin(pi*z)*O.5;
% xe(i) = pi2*sin(pi*z);
% b(i) = h*h*(z**2 - 5*z +4.) * exp(-z)*0.5;
% xe(i) = z*(1-z)*exp(-z);
end
q=matvec(a,x,n);
r=b-q;
p=r;

for k=1:Kmax
    fprintf('Iteration no. : %d\t',k);
    rr1=pdscal(r,r,n);
    q=matvec(a,p,n);
    t=pdscal(p,q,n);
    alpha=rr1/t;
    x=x+(alpha*p);
    r=r-(alpha*q);
    rr2=pdscal(r,r,n);
    rr22=sqrt(rr2);
    fprintf('Norme residu = %7.2e\n',rr22);
    if (rr22<epsilon)
      break;
    end
    beta=rr2/rr1;
    p=r+(beta*p);
end
x
xe
    fprintf('Erreur= %7.2e\n',sqrt(pdscal(x-xe,x-xe,n)));
plot(x)
