!================
module mod_imprim
!================
!
contains
!
!============================
subroutine imprim (u, uexact)
!============================
!
        use mod_data
!
        implicit none
!
        real(kind=8), dimension(:), intent(in) :: u, uexact
        integer                                :: i, k, m, n
        character (len=99)                     :: str, ch1, ch2, charn, charnitert, charniterx
!
        n = size(u)
!
        ch1 = 'solution discrete'
        ch2 = 'solution exacte'
        write(charn ,*) n
        write(charnitert ,*) nitert
        write(charniterx ,*) niterx
!       
        write (str(1:),1) 'SOL'
        k = len(trim(str(1:)))
        write (str(k+1:),2) nitert
        m = len(trim(str(k+1:)))
        do i=1, m
         if (str(k+i:k+i)==' ') str(k+i:k+i)='0'
        end do
        write (str(k+m+1:),3) '.res'
!
        open (unit = 11, file = trim(dirloc)//str, status = 'unknown')
        write(11,*) 'Solution a l"iteration en temps=',trim(adjustl(charnitert)),''
        write(11,*) 'sur ',trim(adjustl(charn)),' noeuds interieurs avec une CL=0 de Dirichlet aux bords.'
        write(11,*) 'Resolution par une ',trim(adjustl(algo)),''
        write(11,*) 'qui converge en ',trim(adjustl(charniterx)),' iteration(s),'
        write(11,*) 'avec une norme de residu a convergence egale a',normresx,''
        write(11,*)
        write(11,4) ch1, ch2
        do i = 1, n
         write (11,5) i, u(i), uexact(i)
        end do
        write(11,*)
        write(11,*) 'norme erreur numerique =', normerrsol
        write(11,*)
        write(11,*) 'norme erreur stationnaire =', normerrsta
        close (11)
!
   1    format(a3)
   2    format(i5)
   3    format(a4)
   4    format(2(17x, a17))
   5    format(i8,2d31.20)
!
!====================
end subroutine imprim
!====================
!
!====================
end module mod_imprim
!====================
