!=================
module mod_secmbre
!=================
!
contains
!
!=========================
subroutine secmbre (u0, b)
!=========================
!
        use mod_data
        use mod_dataproc
!
        implicit none
!
        real(kind=8), dimension(:), intent(in)  :: u0
        real(kind=8), dimension(:), intent(out) :: b
        real(kind=8), dimension(size(b))        :: f
        real(kind=8)                            :: pi, xi, d
        integer                                 :: i, n
!
        n  = size(b)
!
        pi = acos(-1.d0)
        d  = 1./((dx**2)/dt+a2)
!
        do i = 1, n
         xi = (i+(nxl1*moi))*dx
!        f(i) = sin(pi*xi)
         f(i)= 12.
!        f(i) = (xi**2 - 5*xi +4.) * exp(-xi)
        end do
!
        b = dx**2*(f+u0/dt)*d
!
!=====================
end subroutine secmbre
!=====================
!
!=====================
end module mod_secmbre
!=====================
